         page   60,80
;*****************************************************************************
;File:    cpcstart.asm
;Purpose: Startup code for C language control program for Hostess i/S2.
;Company: Comtrol Corporation
;Author:  Craig Harrison
;Ident:   $Id$
;*****************************************************************************
;Copyright 1994 Comtrol Corporation. All rights reserved. Subject to
;developers license agreement.
;*****************************************************************************

.286

ifdef MSMALL
   .MODEL small
else
ifdef MCOMPACT
.MODEL compact
else
ifdef MMEDIUM
.MODEL medium
else
ifdef MLARGE
.MODEL large
else
.ERR "Memory model incorrectly defined"
endif
endif
endif
endif


public	__acrtused		; Microsoft object modules reference this symbol to
	__acrtused = 9876h	; pull in startup code from the library



if @CodeSize eq 0                      ;near code pointer
         extrn      _main:near
else                                   ;far code pointer
         extrn      _main:far
endif


        assume  cs:_TEXT,ds:DGROUP,es:nothing

ifdef MMEDIUM
.CODE _TEXT                      ;code segment (_TEXT)
endif
ifdef MLARGE
.CODE _TEXT                      ;code segment (_TEXT)
endif
ifdef MSMALL
.CODE                            ;code segment (_TEXT)
endif
ifdef MCOMPACT
.CODE                            ;code segment (_TEXT)
endif
         org 0                   ;starting offset

         public  start, cpmain
cpmain   proc
start:
         ;Initialize segment registers
         cli                     ;disable interrupts
         mov   ax,DGROUP
         mov   ds,ax
         mov   es,ax             ;known value, not really needed


         ;Initialize stack
if @DataSize eq 0                ;near data pointers
         assume   ss:DGROUP
         mov   ax,DGROUP
         mov   ss,ax
         mov   sp,offset DGROUP:tos
else                             ;far data pointers
         assume   ss:_STACK
         mov   ax,_STACK
         mov   ss,ax
         mov   sp,offset tos
endif


         ;Invoke "C" main function
         sti                     ;enable interrupts
         call   _main            ;invoke main function which never returns
         jmp   start             ;should never reach here
cpmain   endp



.DATA                            ;initialized data segment (_DATA)
         public   _endcp_seg
_endcp_seg   dw      ENDCP       ;segment after end of control program for
                                 ;  use by "C" code

.CONST                           ;constant data segment (CONST)

.DATA?                           ;uninitialized data segment (_BSS)



;Not using simplified segment directive for stack because MASM mode closes the
;stack segment before we can assign the tos label (see Turbo Assembler 3.0,
;page 115).

if @DataSize eq 0                ;for near data pointers
DGROUP   group      _STACK       ;  stack is part of DGROUP
endif

         public   tos
_STACK   segment   para   stack      'STACK'   ;stack segment (_STACK)
         db         STACK_SIZE   dup   (?)
         align   2               ;make sure SP starts out with word allignment
tos      label   word            ;top of stack
_STACK   ends


.FARDATA                         ;far initialized data seg (FAR_DATA)

.FARDATA?                        ;far uninitialized data seg (FAR_BSS)


ENDCP      segment   para   public   'ENDCP'   ;marks end of control program
ENDCP      ends

         end   start
