/******************************************************************************
File:    DPMMAP.C
Purpose: Prints a memory map of the DPM Area and the line descriptor for the
         CPC.C control program provided with the Hostess i/S2 tool kit.
Company: Comtrol Corporation
Author:  Craig Harrison
Ident:   $Id$
*******************************************************************************
Copyright 1994 Comtrol Corporation. All rights reserved.
Subject to developers license agreement.
******************************************************************************/

#include <stdio.h>
#include <dos.h>
#include "dpram.h"


int main(void)
{
   DPM_T *pMem;
   LINE_T *pLn;
   int i;

   printf("\t\tHostess i/2s Dual Port Memory Map\n\n");
   pMem = (DPM_T *)0;
   printf("%4.4X  Vectors\n",pMem->VectorArea);
   printf("%4.4X  FirmData\n",pMem->FirmData);
   printf("%4.4X  FirmUser\n",&pMem->FirmUser);
   printf("%4.4X  TrBuf\n",pMem->TrBuf);
   printf("%4.4X  TrIx\n",&pMem->TrIx);
   printf("%4.4X  DpSem\n",&pMem->DpSem);
   printf("%4.4X  SFG\n",pMem->Sfg);
   printf("%4.4X  CtlQ->In\n",&pMem->CtlQ.In);
   printf("%4.4X  CtlQ->Out\n",&pMem->CtlQ.Out);
   printf("%4.4X  CtlQ->Buf\n",&pMem->CtlQ.Buf);
   printf("%4.4X  CtlQ->ReplyRdy\n",&pMem->CtlQ.ReplyRdy);
   printf("%4.4X  CtlQ->ReplyBuf\n",pMem->CtlQ.ReplyBuf);
   printf("%4.4X  SysQ->In\n",&pMem->SysQ.In);
   printf("%4.4X  SysQ->Out\n",&pMem->SysQ.Out);
   printf("%4.4X  SysQ->Buf\n",&pMem->SysQ.Buf);
   printf("%4.4X  SysQ->ReplyRdy\n",&pMem->SysQ.ReplyRdy);
   printf("%4.4X  SysQ->ReplyBuf\n",pMem->SysQ.ReplyBuf);
   printf("%4.4X  Fill\n",pMem->Fill);
   printf("%4.4X  Line[0]\n",&pMem->Line[0]);
   printf("%4.4X  Line[1]\n",&pMem->Line[1]);
   printf("%4.4X  TxqBuf[0]\n",&pMem->TxqBuf[0]);
   printf("%4.4X  TxqBuf[1]\n",&pMem->TxqBuf[1]);
   printf("%4.4X  RxqBuf[0]\n",&pMem->RxqBuf[0]);
   printf("%4.4X  RxqBuf[1]\n",&pMem->RxqBuf[1]);
   printf("%4.4X  TxbqBuf[0]\n",&pMem->TxbqBuf[0]);
   printf("%4.4X  TxbqBuf[1]\n",&pMem->TxbqBuf[1]);
   printf("%4.4X  RxbqBuf[0]\n",&pMem->RxbqBuf[0]);
   printf("%4.4X  RxbqBuf[1]\n",&pMem->RxbqBuf[1]);
   printf("%4.4X  EndDPM\n",&pMem->EndDPM);

   putchar(12);
   printf("\n\t\tLine Structure Member Offsets\n\n");
   pLn = (LINE_T *)0;
   printf("%4.4X  LineNum\n",(UWORD_T)&pLn->LineNum);
   printf("%4.4X  BaseIo\n",(UWORD_T)&pLn->BaseIo);
   printf("%4.4X  Status\n",&pLn->Status);
   printf("%4.4X  TxState\n",&pLn->TxState);
   printf("%4.4X  RxState\n",&pLn->RxState);
   printf("%4.4X  AltDtrMask\n",&pLn->AltDtrMask);
   printf("%4.4X  TxClkMask\n",&pLn->TxClkMask);
   printf("%4.4X  Timeout\n",&pLn->Timeout);
   printf("%4.4X  Modem\n",&pLn->Modem);
   printf("%4.4X  WR2\n",&pLn->WR2_);
   printf("%4.4X  WR3\n",&pLn->WR3_);
   printf("%4.4X  WR4\n",&pLn->WR4_);
   printf("%4.4X  WR5\n",&pLn->WR5_);
   printf("%4.4X  WR12\n",&pLn->WR12_);
   printf("%4.4X  WR13\n",&pLn->WR13_);
   printf("%4.4X  WR15\n",&pLn->WR15_);
   printf("%4.4X  TxDmaChan\n",&pLn->TxDmaChan);
   printf("%4.4X  RxDmaChan\n",&pLn->RxDmaChan);
   printf("%4.4X  EnTxDma\n",&pLn->EnTxDma);
   printf("%4.4X  EnRxDma\n",&pLn->EnRxDma);
   printf("%4.4X  DisTxDma\n",&pLn->DisTxDma);
   printf("%4.4X  DisRxDma\n",&pLn->DisRxDma);
   printf("%4.4X  TxqIn\n",&pLn->TxqIn);
   printf("%4.4X  TxqOut\n",&pLn->TxqOut);
   printf("%4.4X  TxqCtl\n",&pLn->TxqCtl);
   printf("%4.4X  TxqSys\n",&pLn->TxqSys);
   printf("%4.4X  RxqIn\n",&pLn->RxqIn);
   printf("%4.4X  RxqOut\n",&pLn->RxqOut);
   printf("%4.4X  RxqCtl\n",&pLn->RxqCtl);
   printf("%4.4X  RxqSys\n",&pLn->RxqSys);
   printf("%4.4X  TxbqIn\n",&pLn->TxbqIn);
   printf("%4.4X  TxbqOut\n",&pLn->TxbqOut);
   printf("%4.4X  TxbqCnt\n",&pLn->TxbqCnt);
   printf("%4.4X  RxbqIn\n",&pLn->RxbqIn);
   printf("%4.4X  RxbqOut\n",&pLn->RxbqOut);
   printf("%4.4X  RxbqCnt\n",&pLn->RxbqCnt);
   printf("%4.4X  RxbqCurBuf\n",&pLn->RxbqCurBuf);
   printf("%4.4X  RxbqCurCnt\n",&pLn->RxbqCurCnt);
   printf("%4.4X  TxbqRetryCnt\n",&pLn->TxbqRetryCnt);
   for(i = 0;i < TXBQ_SIZE;i++)
   {
      printf("%4.4X  Txb[%d].BufCtl\n",&pLn->Txb[i].BufCtl,i);
      printf("%4.4X  Txb[%d].BufHi\n",&pLn->Txb[i].BufHi,i);
      printf("%4.4X  Txb[%d].BufLo\n",&pLn->Txb[i].BufLo,i);
      printf("%4.4X  Txb[%d].BufSys\n",&pLn->Txb[i].BufSys,i);
      printf("%4.4X  Txb[%d].Cnt\n",&pLn->Txb[i].Cnt,i);
   }
   for(i = 0;i < RXBQ_SIZE;i++)
   {
      printf("%4.4X  Rxb[%d].BufCtl\n",&pLn->Rxb[i].BufCtl,i);
      printf("%4.4X  Rxb[%d].BufHi\n",&pLn->Rxb[i].BufHi,i);
      printf("%4.4X  Rxb[%d].BufLo\n",&pLn->Rxb[i].BufLo,i);
      printf("%4.4X  Rxb[%d].BufSys\n",&pLn->Rxb[i].BufSys,i);
      printf("%4.4X  Rxb[%d].Cnt\n",&pLn->Rxb[i].Cnt,i);
   }
   printf("%4.4X  Fill2\n",pLn->Fill2);

   return(0);
}
