/******************************************************************************
File:     test.h
Purpose:  Include file for Hostess i/S2 test program, TEST.C.
Company:  Comtrol Corporation
Author:   Craig Harrison
Ident:    $Id$
*******************************************************************************
 Copyright 1994 Comtrol Corporation. All rights reserved. Subject to
 developers license agreement.
******************************************************************************/

#define NUM_LN 2                    /* max number of lines supported */
#define PRINTCNT 100
#define IRQ_NUM 10                  /* IRQ number for CTL to SYS interrupts */
#define BUF_SIZE 1026
#define OUTBUF_SIZE 2048
#define NUM_DATARATES 13
#define TRUE 1
#define FALSE 0

#define TWRA_WRSIZE BUF_SIZE-2      /* TestWrRdAsync() parms */
#define TWRA_BAUD MSG_BAUD_115200
#define TWH_CLK MSG_CLK_2           /* TestWrHdlc() parms */
#define TWH_DATARATE 9600L          /* sets data rate if TWH_CLK = MSG_CLK_2 */
#define TWH_WRSIZE 128

#define TWRS_WRSIZE BUF_SIZE-2      /* sync write/read test parms */
#define TWRS_DATARATE 9600L

#define TWB_CLK MSG_CLK_2           /* TestWrBisync() parms */
#define TWB_DATARATE 9600L          /* sets data rate if TWB_CLK = MSG_CLK_2 */
#define TWB_WRSIZE 128

#define SOH              0x01       /* SOH control character */
#define ETX              0x03       /* ETX control character */
#define SYN              0x16       /* SYN control character */


void interrupt far IntHandler(void);
void ProcessMsg(void);
void ExitTest(void);
int GetRandom(int,int);
void TestCtrlMsg(void);
void TestOpenAsync_Close(void);
void TestWrRdAsync(void);
void TestModemState(void);
void TestOpenHdlc_Close(void);
void TestWrHdlc(void);
void TestRdHdlc(void);
void TestWrRdHdlc(void);
void TestOpenBisync_Close(void);
void TestWrBisync(void);
void TestRdBisync(void);
void TestWrRdBisync(void);
void TestSfg1(void);
void TestSfg2(void);
void TestAckAsync(void);


typedef struct                         /* info on line under test */
{
   int nLnOpen;                        /* set if line open */
   int nLoop1;                         /* loop counter */
   int nLoop2;                         /* loop counter */
   int nTxCnt;                         /* transmit character counter */
   int nTxTotal;                       /* size of transmit */
   int nRxCnt;                         /* receive character counter */
   int nRxTotal;                       /* size of receive */
   int nTxSeq;                         /* Tx sequence number */
   int nRxSeq;                         /* Rx sequence number */
   int nCnt1,nCnt2;                    /* general purpose counters */
   char sRxBuf[BUF_SIZE];              /* Rx data buffer */
   char sTxBuf[BUF_SIZE];              /* Tx data buffer */
   unsigned char byStatus;             /* general purpose status byte */
   int nTxBufCnt;                      /* current Tx buffer count */
   int nRxBufCnt;                      /* current Rx buffer count */
} LNINFO_T;

typedef struct                     /* modem states */
{
   int nOut;                       /* modem output flags (used with open) */
   int nDtr;                       /* DTR state (used with hiChangeModem) */
   int nRts;                       /* RTS state (used with hiChangeModem) */
   int nIn;                        /* modem input flags */
} MODEM_T;
#define NUM_MDMSTATE 4             /* number of modem state combinations */








